// Commands.h: interface of the CCommands class
//
//////////////////////////////////////////////////////////////////////

#include "xkeymacsdll.h"

#if !defined(AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_)
#define AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum SEARCH_DIRECTION { NA, FORWARD, BACKWARD, AGAIN };
enum MAXIMIZE_DIRECTION { VERTICAL, HORIZONTAL, MAX_MAXIMIZE_DIRECTION };
enum INPUT_METHOD_OPEN_STATUS {CLOSE_INPUT_METHOD, OPEN_INPUT_METHOD, TOGGLE_INPUT_METHOD};
enum CONSOLE_MENU_EDIT { CMD_MARK = 1, CMD_COPY, CMD_PASTE, CMD_SELECT_ALL, CMD_SCROLL, CMD_FIND };
enum CONSOLE_MENU { CMD_RESTORE = 1, CMD_MOVE, CMD_SIZE, CMD_MINIMIZE, CMD_MAXIMIZE, CMD_CLOSE, CMD_EDIT, CMD_DEFAULTS, CMD_PROPERTIES };

class AFX_EXT_CLASS CCommands  
{
public:
	static int KillLineForAllFormat();
	static int TransposeLines();
	static int FindNext();
	static int Find();
	static int Print();
	static int New();
	static int Cut();
	static int Paste();
	static int Copy();
	static void SetTemporarilyDisableXKeymacs(BOOL bTemporarilyDisableXKeymacs);
	static BOOL IsTemporarilyDisableXKeymacs();
	static int TemporarilyDisableXKeymacs();
	static int Redo();
	static int PassThrough();
	static BOOL MoveCaret(BYTE bVk, BOOL bCtrl = FALSE);
	static int MaximizeHorizontally();
	static int MaximizeVertically();
	static int Maximize();
	static int Minimize();
	static int Size();
	static int Move();
	static int Restore();
	static void SetMark(BOOL bSetMark);
	static int IsearchForwardBeta();
	static int IsearchBackwardBeta();
	static int IsearchInput(BYTE bVk);
	static BOOL IsSetMark();
	static int BackQuote();
	static int Tilde();
	static int Escape();
	static int C_Eisu();
	static int C_();
	static int SwitchToBuffer();
	static int SwitchBetweenInputLocales();
	static int CallLastKbdMacro();
	static int EndKbdMacro();
	static int StartKbdMacro();
	static int SelectAll();
	static int MarkWholeBuffer();
	static int KillWord();
	static void SetLastCommand(int (*LastCommand)());
	static int KillBuffer();
	static int Reset(int rc);
	static int CloseInputMethod();
	static int OpenInputMethod();
	static int NumericArgument(int n);
	static void ClearNumericArgument();
	static int GetNumericArgument();
	static int EnableOrDisableXKeymacs();
	static int IsearchForward();
	static int IsearchBackward();
	static int TransposeChars();
	static int Recenter();
	static int Repeat(BYTE bVk);
	static void bC_u(BOOL b);
	static BOOL bC_u();
	static int UniversalArgument();
	static int NumericArgumentMinus();
	static int NumericArgument9();
	static int NumericArgument8();
	static int NumericArgument7();
	static int NumericArgument6();
	static int NumericArgument5();
	static int NumericArgument4();
	static int NumericArgument3();
	static int NumericArgument2();
	static int NumericArgument1();
	static int NumericArgument0();
	static int MetaAlt();
	static int MetaEscape();
	static int Meta();
	static void bM_(BOOL b);
	static BOOL bM_();
	static int Ignore();
	static int ShellCommand();
	static int YankPop();
	static int Yank();
	static int KillRingSave();
	static int KillRegion();
	static int WriteFile();
	static int C_x();
	static void Reset();
	static void bC_(BOOL b);
	static BOOL bC_();
	static void bC_x(BOOL b);
	static BOOL bC_x();
	static int ScrollDown();
	static int ScrollUp();
	static int SaveBuffer();
	static int MarkPage();
	static int Enter();
	static int TabToTabStop();
	static int FindFile();
	static int KeyboardQuit();
	static int SetMarkCommand();
	static int IconifyOrDeiconifyFrame();
	static int SaveBuffersKillEmacs();
	static int Undo();
	static int KillLine();
	static int DeleteChar();
	static int DeleteBackwardChar();
	static int EndOfBuffer();
	static int BeginningOfBuffer();
	static int QueryReplaceRegexp();
	static int QueryReplace();
	static int ToggleInputMethod();
	static int OpenLine();
	static int PreviousLine();
	static int NextLine();
	static int BackwardWord();
	static int ForwardWord();
	static int EndOfLine();
	static int BackwardChar();
	static int BeginningOfLine();
	static int ForwardChar();
	CCommands();
	virtual ~CCommands();

protected:
	static int KillLine(BOOL bAllFormat, int (*pCommand)() = KillLine);
	static void DeleteLastReturnClipboardData(const int nID = 0);
	static BOOL AddClipboardData(const char* const pAddedString, const BOOL bTop = FALSE, const int nID = 0);
	static BOOL IsEmptyClipboardData(const int nID = 0);
	static int FindReturnFromClipboardData(const int nID = 0);
	static void Cut_();
	static void RestoreClipboardData(const int nID = 0);
	static void CaptureClipboardData(const int nID = 0);
	static CArray<CClipboardSnap *, CClipboardSnap *> m_oClipboardData;
	static int SystemMenuEdit(const CONSOLE_MENU_EDIT nDown);
	static int Click(const POINT* const pClickPoint);
	static int SystemMenu(const CONSOLE_MENU nDown);
	static BOOL m_bTemporarilyDisableXKeymacs;
	static int Maximize(MAXIMIZE_DIRECTION direction);
	static DWORD DeactivateMark();
	static BOOL m_bFirstFindDialog;
	static int Isearch(int& nStep, const BYTE bVk, const SEARCH_DIRECTION direction);
	static int IsearchInputOnIME(const BYTE bVk, const int nStep);
	static BOOL SetCaretPosition();
	static void GetCaretPosition();
	static CPtrList m_FindText;
	static CPtrList m_ScrollInfo;
	static CPtrList m_CaretPos;
	static BOOL m_bIsearch;
	static int Isearch(SEARCH_DIRECTION direction);
	static void Copy_();
	static BYTE GetDirectionBackwardKey();
	static BYTE GetDirectionForwardKey();
	static BYTE GetSearchOptionKey();
	static BYTE GetFindWhatKey();
	static void OpenFindDialog();
	static BOOL m_bC_;
	static void CdSdKduSuCu(BYTE bVk);
	static int (*m_LastCommand)();
	static void SetInputMethodOpenStatus(INPUT_METHOD_OPEN_STATUS status);
	static void SearchSetDirection(SEARCH_DIRECTION direction);
	static SEARCH_DIRECTION m_SearchDirection;
	static int Search(SEARCH_DIRECTION direction);
	static void DecreaseNumericArgument();
	static BOOL CopyBackCharacter();
	static BOOL CopyNextCharacter();
	static BOOL m_bC_u;
	static BOOL m_bNegativeNumericArgument;
	static BOOL m_bDefaultNumericArgument;
	static BOOL m_bM_;
	static BOOL m_bC_x;
	static int ScrollUpDown(BOOL bUp);
	static DWORD ClickCaret();
	static BOOL m_bSetMark;
	static void ReleaseKey(BYTE bVk);
	static void DepressKey(BYTE bVk);
	static void SdKduSu(BYTE bVk1, BYTE bVk2 = 0, BYTE bVk3 = 0);
	static void AdKduAu(BYTE bVk1, BYTE bVk2 = 0, BYTE bVk3 = 0);
	static void CdKduCu(BYTE bVk1, BYTE bVk2 = 0);
	static void Kdu(BYTE bVk1 = 0, BYTE bVk2 = 0, BYTE bVk3 = 0, BYTE bVk4 = 0);
	static DWORD m_nNumericArgument;
};

typedef struct KeyBind
{
	int nCommandType;
	BYTE bVk;
	int nControlID;
} KeyBind_t;

enum { MAX_KEY_BIND = 8 };

typedef struct Command
{
	char *szCommandName;
	int nCategoryID;
	int nDescriptionID;
	int (*fCommand)();
	KeyBind_t keybind[MAX_KEY_BIND];
} Command_t;

#include "../xkeymacs/resource.h"

static const Command_t Commands[] = {
	{"[unassigned]",				0,				0,									NULL,								{'\0'}},
	{"C-x",							0,				IDS_CONTROL_X_PREFIX_D,				CCommands::C_x,						{'\0'}},
	{"C-",							IDS_OTHER,		IDS_CONTROL_D,						CCommands::C_,						{{NONE, VK_CONTROL, 0},
																															 {NONE, VK_LCONTROL, 0},
																															 {NONE, VK_RCONTROL, 0},
																															 {'\0'}}},
	{"C- for Eisu",					0,				IDS_CONTROL_PREFIX_D,				CCommands::C_Eisu,					{'\0'}},
	{"Close Input Method",			IDS_IME,		IDS_CLOSE_INPUT_METHOD_D,			CCommands::CloseInputMethod,		{'\0'}},
	{"Copy",						IDS_OTHER,		IDS_COPY_D,							CCommands::Copy,					{'\0'}},
	{"Cut",							IDS_OTHER,		IDS_CUT_D,							CCommands::Cut,						{'\0'}},
	{"Enable or Disable XKeymacs",	IDS_OTHER,		IDS_ENABLE_OR_DISABLE_XKEYMACS_D,	CCommands::EnableOrDisableXKeymacs,	{{CONTROL, 'Q', IDC_CQ},
																															 {CONTROL+SHIFT, 'Q', IDC_CQ},
																															 {'\0'}}},
	{"Enter",						IDS_OTHER,		IDS_ENTER_D,						CCommands::Enter,					{{CONTROL, 'M', IDC_CM},
																															 {CONTROL+SHIFT, 'M', IDC_CM},
																															 {'\0'}}},
	{"Esc",							IDS_OTHER,		IDS_ESCAPE_D,						CCommands::Escape,					{'\0'}},
	{"Find",						IDS_OTHER,		IDS_FIND_D,							CCommands::Find,					{'\0'}},
	{"Find Next",					IDS_OTHER,		IDS_FIND_NEXT_D,					CCommands::FindNext,				{'\0'}},
	{"Ignore",						IDS_OTHER,		IDS_IGNORE_D,						CCommands::Ignore,					{'\0'}},
	{"Kill Line for All Format",	IDS_OTHER,		IDS_KILL_LINE_FOR_ALL_FORMAT_D,		CCommands::KillLineForAllFormat,	{'\0'}},
	{"Maximize",					IDS_OTHER,		IDS_MAXIMIZE_D,						CCommands::Maximize,				{'\0'}},
	{"Maximize Horizontally",		IDS_OTHER,		IDS_MAXIMIZE_HORIZONTALLY_D,		CCommands::MaximizeHorizontally,	{'\0'}},
	{"Maximize Vertically",			IDS_OTHER,		IDS_MAXIMIZE_VERTICALLY_D,			CCommands::MaximizeVertically,		{'\0'}},
	{"Meta",						IDS_OTHER,		IDS_META_PREFIX_D,					CCommands::Meta,					{{CONTROL, 0xDB, IDC_SQUARE_BRA},
																															 {CONTROL+SHIFT, 0xDB, IDC_SQUARE_BRA},
																															 {'\0'}}},	// VK_OEM_4
	{"Meta for Alt",				IDS_OTHER,		IDS_META_D,							CCommands::MetaAlt,					{{NONE, VK_MENU, IDC_ALT},
																															 {NONE, VK_LMENU, IDC_LEFT_ALT},
																															 {NONE, VK_RMENU, IDC_RIGHT_ALT},
																															 {'\0'}}},
	{"Meta for Escape",				IDS_OTHER,		IDS_META_PREFIX_AND_ORIGINAL_D,		CCommands::MetaEscape,				{{NONE, VK_ESCAPE, IDC_ESCAPE},
																															 {NONE+SHIFT, VK_ESCAPE, IDC_ESCAPE},
																															 {'\0'}}},	// add SHIFT
	{"Minimize",					IDS_OTHER,		IDS_MINIMIZE_D,						CCommands::Minimize,				{'\0'}},
	{"Move",						IDS_OTHER,		IDS_MOVE_D,							CCommands::Move,					{'\0'}},
	{"New",							IDS_OTHER,		IDS_NEW_D,							CCommands::New,						{'\0'}},
	{"Open Input Method",			IDS_IME,		IDS_OPEN_INPUT_METHOD_D,			CCommands::OpenInputMethod,			{'\0'}},
	{"Pass Through",				IDS_OTHER,		IDS_PASS_THROUGH_D,					CCommands::PassThrough,				{'\0'}},
	{"Paste",						IDS_OTHER,		IDS_PASTE_D,						CCommands::Paste,					{'\0'}},
	{"Print",						IDS_OTHER,		IDS_PRINT_D,						CCommands::Print,					{'\0'}},
	{"Redo",						IDS_OTHER,		IDS_REDO_D,							CCommands::Redo,					{'\0'}},
	{"Restore",						IDS_OTHER,		IDS_RESTORE_D,						CCommands::Restore,					{'\0'}},
	{"Select All",					IDS_OTHER,		IDS_SELECT_ALL_D,					CCommands::SelectAll,				{'\0'}},
	{"Size",						IDS_OTHER,		IDS_SIZE_D,							CCommands::Size,					{'\0'}},
	{"Switch Between Input Locales",IDS_IME,		IDS_SWITCH_BETWEEN_INPUT_LOCALES_D,	CCommands::SwitchBetweenInputLocales,	{'\0'}},
	{"Temporarily Disable XKeymacs",IDS_OTHER,		IDS_TEMPORARILY_DISABLE_XKEYMACS_D,	CCommands::TemporarilyDisableXKeymacs,	{'\0'}},
	{"~",							IDS_OTHER,		IDS_TILDE_D,						CCommands::Tilde,					{'\0'}},
	{"`",							IDS_OTHER,		IDS_BACK_QUOTE_D,					CCommands::BackQuote,				{'\0'}},
	{"backward-char",				IDS_MOTION,		IDS_BACKWARD_CHAR_D,				CCommands::BackwardChar,			{{CONTROL, 'B', IDC_CB},
																															 {CONTROL+SHIFT, 'B', IDC_CB},
																															 {'\0'}}},
	{"backward-word",				IDS_MOTION,		IDS_BACKWARD_WORD_D,				CCommands::BackwardWord,			{{META, 'B', IDC_MB},
																															 {META+SHIFT, 'B', IDC_MB},
																															 {'\0'}}},
	{"beginning-of-buffer",			IDS_MOTION,		IDS_BEGINNING_OF_BUFFER_D,			CCommands::BeginningOfBuffer,		{{META+SHIFT, 0xBC, IDC_MSCOMMA},
																															 {'\0'}}},	// VK_OEM_COMMA
	{"beginning-of-line",			IDS_MOTION,		IDS_BEGINNING_OF_LINE_D,			CCommands::BeginningOfLine,			{{CONTROL, 'A', IDC_CA},
																															 {CONTROL+SHIFT, 'A', IDC_CA},
																															 {'\0'}}},
	{"call-last-kbd-macro",			IDS_OTHER,		IDS_CALL_LAST_KBD_MACRO_D,			CCommands::CallLastKbdMacro,		{{CONTROLX, 'E', IDC_CXE},
																															 {CONTROLX+SHIFT, 'E', IDC_CXE},
																															 {'\0'}}},
	{"delete-backward-char",		IDS_KILL,		IDS_DELETE_BACKWARD_CHAR_D,			CCommands::DeleteBackwardChar,		{{CONTROL, 'H', IDC_CH},
																															 {CONTROL+SHIFT, 'H', IDC_CH},
																															 {'\0'}}},
	{"delete-char",					IDS_KILL,		IDS_DELETE_CHAR_D,					CCommands::DeleteChar,				{{CONTROL, 'D', IDC_CD},
																															 {CONTROL+SHIFT, 'D', IDC_CD},
																															 {'\0'}}},
	{"end-kbd-macro",				IDS_OTHER,		IDS_END_KBD_MACRO_D,				CCommands::EndKbdMacro,				{{CONTROLX+SHIFT, '0', IDC_CXS0},
																															 {'\0'}}},
	{"end-of-buffer",				IDS_MOTION,		IDS_END_OF_BUFFER_D,				CCommands::EndOfBuffer,				{{META+SHIFT, 0xBE, IDC_MSPERIOD},
																															 {'\0'}}},	// VK_OEM_PERIOD
	{"end-of-line",					IDS_MOTION,		IDS_END_OF_LINE_D,					CCommands::EndOfLine,				{{CONTROL, 'E', IDC_CE},
																															 {CONTROL+SHIFT, 'E', IDC_CE},
																															 {'\0'}}},
	{"find-file",					IDS_FILES,		IDS_FIND_FILE_D,					CCommands::FindFile,				{{CONTROL+CONTROLX, 'F', IDC_CXCF},
																															 {CONTROL+SHIFT+CONTROLX, 'F', IDC_CXCF},
																															 {'\0'}}},
	{"forward-char",				IDS_MOTION,		IDS_FORWARD_CHAR_D,					CCommands::ForwardChar,				{{CONTROL, 'F', IDC_CF},
																															 {CONTROL+SHIFT, 'F', IDC_CF},
																															 {'\0'}}},
	{"forward-word",				IDS_MOTION,		IDS_FORWARD_WORD_D,					CCommands::ForwardWord,				{{META, 'F', IDC_MF},
																															 {META+SHIFT, 'F', IDC_MF},
																															 {'\0'}}},
	{"iconify-or-deiconify-frame",	IDS_WINDOW,		IDS_ICONIFY_OR_DEICONIFY_FRAME_D,	CCommands::IconifyOrDeiconifyFrame,	{{CONTROL, 'Z', IDC_CZ},
																															 {CONTROL+SHIFT, 'Z', IDC_CZ},
																															 {'\0'}}},
	{"isearch-backward",			IDS_SEARCH,		IDS_ISEARCH_BACKWARD_D,				CCommands::IsearchBackward,			{{CONTROL, 'R', IDC_CR},
																															 {CONTROL+SHIFT, 'R', IDC_CR},
																															 {'\0'}}},
	{"isearch-backward-beta",		IDS_SEARCH,		IDS_ISEARCH_BACKWARD_D,				CCommands::IsearchBackwardBeta,		{'\0'}},
	{"isearch-forward",				IDS_SEARCH,		IDS_ISEARCH_FORWARD_D,				CCommands::IsearchForward,			{{CONTROL, 'S', IDC_CS},
																															 {CONTROL+SHIFT, 'S', IDC_CS},
																															 {'\0'}}},
	{"isearch-forward-beta",		IDS_SEARCH,		IDS_ISEARCH_FORWARD_D,				CCommands::IsearchForwardBeta,		{'\0'}},
	{"keyboard-quit",				IDS_RECOVERY,	IDS_KEYBOARD_QUIT_D,				CCommands::KeyboardQuit,			{{CONTROL, 'G', IDC_CG},
																															 {CONTROL+SHIFT, 'G', IDC_CG},
																															 {'\0'}}},
	{"kill-buffer",					IDS_FILES,		IDS_KILL_BUFFER_D,					CCommands::KillBuffer,				{{CONTROLX, 'K', IDC_CXK},
																															 {SHIFT+CONTROLX, 'K', IDC_CXK},
																															 {'\0'}}},
	{"kill-line",					IDS_KILL,		IDS_KILL_LINE_D,					CCommands::KillLine,				{{CONTROL, 'K', IDC_CK},
																															 {CONTROL+SHIFT, 'K', IDC_CK},
																															 {'\0'}}},
	{"kill-region",					IDS_KILL,		IDS_KILL_REGION_D,					CCommands::KillRegion,				{{CONTROL, 'W', IDC_CW},
																															 {CONTROL+SHIFT, 'W', IDC_CW},
																															 {'\0'}}},
	{"kill-ring-save",				IDS_KILL,		IDS_KILL_RING_SAVE_D,				CCommands::KillRingSave,			{{META, 'W', IDC_MW},
																															 {META+SHIFT, 'W', IDC_MW},
																															 {'\0'}}},
	{"kill-word",					IDS_KILL,		IDS_KILL_WORD_D,					CCommands::KillWord,				{{META, 'D', IDC_MD},
																															 {META+SHIFT, 'D', IDC_MD},
																															 {'\0'}}},
	{"mark-page",					IDS_OTHER,		IDS_MARK_PAGE_D,					CCommands::MarkPage,				{{CONTROL+CONTROLX, 'P', IDC_CXCP},
																															 {CONTROL+SHIFT+CONTROLX, 'P', IDC_CXCP},
																															 {'\0'}}},
	{"mark-whole-buffer",			IDS_OTHER,		IDS_MARK_WHOLE_BUFFER_D,			CCommands::MarkWholeBuffer,			{{CONTROLX, 'H', IDC_CXH},
																															 {CONTROLX+SHIFT, 'H', IDC_CXH},
																															 {'\0'}}},
	{"next-line",					IDS_MOTION,		IDS_NEXT_LINE_D,					CCommands::NextLine,				{{CONTROL, 'N', IDC_CN},
																															 {CONTROL+SHIFT, 'N', IDC_CN},
																															 {'\0'}}},
	{"numeric argument 0",			IDS_OTHER,		IDS_DIGIT_ARGUMENT0_D,				CCommands::NumericArgument0,		{{CONTROL, '0', IDC_CDIGIT},
																															 {META, '0', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 1",			IDS_OTHER,		IDS_DIGIT_ARGUMENT1_D,				CCommands::NumericArgument1,		{{CONTROL, '1', IDC_CDIGIT},
																															 {META, '1', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 2",			IDS_OTHER,		IDS_DIGIT_ARGUMENT2_D,				CCommands::NumericArgument2,		{{CONTROL, '2', IDC_CDIGIT},
																															 {META, '2', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 3",			IDS_OTHER,		IDS_DIGIT_ARGUMENT3_D,				CCommands::NumericArgument3,		{{CONTROL, '3', IDC_CDIGIT},
																															 {META, '3', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 4",			IDS_OTHER,		IDS_DIGIT_ARGUMENT4_D,				CCommands::NumericArgument4,		{{CONTROL, '4', IDC_CDIGIT},
																															 {META, '4', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 5",			IDS_OTHER,		IDS_DIGIT_ARGUMENT5_D,				CCommands::NumericArgument5,		{{CONTROL, '5', IDC_CDIGIT},
																															 {META, '5', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 6",			IDS_OTHER,		IDS_DIGIT_ARGUMENT6_D,				CCommands::NumericArgument6,		{{CONTROL, '6', IDC_CDIGIT},
																															 {META, '6', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 7",			IDS_OTHER,		IDS_DIGIT_ARGUMENT7_D,				CCommands::NumericArgument7,		{{CONTROL, '7', IDC_CDIGIT},
																															 {META, '7', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 8",			IDS_OTHER,		IDS_DIGIT_ARGUMENT8_D,				CCommands::NumericArgument8,		{{CONTROL, '8', IDC_CDIGIT},
																															 {META, '8', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument 9",			IDS_OTHER,		IDS_DIGIT_ARGUMENT9_D,				CCommands::NumericArgument9,		{{CONTROL, '9', IDC_CDIGIT},
																															 {META, '9', IDC_CDIGIT},
																															 {'\0'}}},
	{"numeric argument -",			IDS_OTHER,		IDS_NEGATIVE_ARGUMENT_D,			CCommands::NumericArgumentMinus,	{{CONTROL, 0xBD, IDC_CDIGIT},
																															 {META, 0xBD, IDC_CDIGIT},
																															 {'\0'}}},
	{"open-line",					IDS_OTHER,		IDS_OPEN_LINE_D,					CCommands::OpenLine,				{{CONTROL, 'O', IDC_CO},
																															 {CONTROL+SHIFT, 'O', IDC_CO},
																															 {'\0'}}},
	{"previous-line",				IDS_MOTION,		IDS_PREVIOUS_LINE_D,				CCommands::PreviousLine,			{{CONTROL, 'P', IDC_CP},
																															 {CONTROL+SHIFT, 'P', IDC_CP},
																															{'\0'}}},
	{"query-replace",				IDS_SEARCH,		IDS_QUERY_REPLACE_D,				CCommands::QueryReplace,			{{META+SHIFT, '5', IDC_MS5},
																															 {'\0'}}},
	{"query-replace-regexp",		IDS_SEARCH,		IDS_QUERY_REPLACE_REGEXP_D,			CCommands::QueryReplaceRegexp,		{{CONTROL+META+SHIFT, '5', IDC_CMS5},
																															 {'\0'}}},
	{"recenter",					IDS_MOTION,		IDS_RECENTER_D,						CCommands::Recenter,				{{CONTROL, 'L', IDC_CL},
																															 {CONTROL+SHIFT, 'L', IDC_CL},
																															 {'\0'}}},
	{"save-buffer",					IDS_FILES,		IDS_SAVE_BUFFER_D,					CCommands::SaveBuffer,				{{CONTROL+CONTROLX, 'S', IDC_CXCS},
																															 {CONTROL+SHIFT+CONTROLX, 'S', IDC_CXCS},
																															 {'\0'}}},
	{"save-buffers-kill-emacs",		IDS_WINDOW,		IDS_SAVE_BUFFERS_KILL_EMACS_D,		CCommands::SaveBuffersKillEmacs,	{{CONTROL+CONTROLX, 'C', IDC_CXCC},
																															 {CONTROL+SHIFT+CONTROLX, 'C', IDC_CXCC},
																															 {'\0'}}},
	{"scroll-down",					IDS_MOTION,		IDS_SCROLL_DOWN_D,					CCommands::ScrollDown,				{{META, 'V', IDC_MV},
																															 {META+SHIFT, 'V', IDC_MV},
																															 {'\0'}}},
	{"scroll-up",					IDS_MOTION,		IDS_SCROLL_UP_D,					CCommands::ScrollUp,				{{CONTROL, 'V', IDC_CV},
																															 {CONTROL+SHIFT, 'V', IDC_CV},
																															 {'\0'}}},
	{"set-mark-command",			IDS_OTHER,		IDS_SET_MARK_COMMAND_D,				CCommands::SetMarkCommand,			{{CONTROL, VK_SPACE, IDC_CSPACE},
																															 {CONTROL+SHIFT, VK_SPACE, IDC_CSPACE},
																															 {'\0'}}},
	{"shell-command",				IDS_OTHER,		IDS_SHELL_COMMAND_D,				CCommands::ShellCommand,			{{META+SHIFT, '1', IDC_MS1},
																															 {'\0'}}},
	{"start-kbd-macro",				IDS_OTHER,		IDS_START_KBD_MACRO_D,				CCommands::StartKbdMacro,			{{CONTROLX+SHIFT, '9', IDC_CXS9},
																															 {'\0'}}},
	{"switch-to-buffer",			IDS_OTHER,		IDS_SWITCH_TO_BUFFER_D,				CCommands::SwitchToBuffer,			{{CONTROLX, 'B', IDC_CXB},
																															 {CONTROLX+SHIFT, 'B', IDC_CXB},
																															 {'\0'}}},
	{"tab-to-tab-stop",				IDS_OTHER,		IDS_TAB_D,							CCommands::TabToTabStop,			{{CONTROL, 'I', IDC_CI},
																															 {CONTROL+SHIFT, 'I', IDC_CI},
																															 {META, 'I', IDC_MI},
																															 {META+SHIFT, 'I', IDC_MI},
																															 {'\0'}}},
	{"toggle-input-method",			IDS_IME,		IDS_TOGGLE_WIN32IME_MODE_D,			CCommands::ToggleInputMethod,		{{CONTROL+CONTROLX, 'J', IDC_CXCJ},
																															 {CONTROL+SHIFT+CONTROLX, 'J', IDC_CXCJ},
																															 {CONTROL, 'O', IDC_CO2},
																															 {CONTROL+SHIFT, 'O', IDC_CO2},
																															 {CONTROL, 0xDC, IDC_CBACKSLASH},
																															 {CONTROL, 0xE2, IDC_CBACKSLASH_106},
																															 {'\0'}}},
	{"transpose-chars",				IDS_KILL,		IDS_TRANSPOSE_CHARS_D,				CCommands::TransposeChars,			{{CONTROL, 'T', IDC_CT},
																															 {CONTROL+SHIFT, 'T', IDC_CT},
																															 {'\0'}}},
	{"transpose-lines",				IDS_KILL,		IDS_TRANSPOSE_LINES_D,				CCommands::TransposeLines,			{{CONTROL+CONTROLX, 'T', IDC_CXCT},
																															 {CONTROL+SHIFT+CONTROLX, 'T', IDC_CXCT},
																															 {'\0'}}},
	{"undo",						IDS_RECOVERY,	IDS_UNDO_D,							CCommands::Undo,					{{CONTROLX, 'U', IDC_CXU},
																															 {CONTROL+SHIFT, 0xBD, IDC_C_},
																															 {CONTROL, 0xBF, IDC_CSLASH},
																															 {'\0'}}},
	{"universal-argument",			IDS_OTHER,		IDS_UNIVERSAL_ARGUMENT_D,			CCommands::UniversalArgument,		{{CONTROL, 'U', IDC_CU},
																															 {CONTROL+SHIFT, 'U', IDC_CU},
																															 {'\0'}}},
	{"write-file",					IDS_FILES,		IDS_WRITE_FILE_D,					CCommands::WriteFile,				{{CONTROL+CONTROLX, 'W', IDC_CXCW},
																															 {CONTROL+SHIFT+CONTROLX, 'W', IDC_CXCW},
																															 {'\0'}}},
	{"yank",						IDS_KILL,		IDS_YANK_D,							CCommands::Yank,					{{CONTROL, 'Y', IDC_CY},
																															 {CONTROL+SHIFT, 'Y', IDC_CY},
																															 {'\0'}}},
	{"yank-pop",					IDS_KILL,		IDS_YANK_POP_D,						CCommands::YankPop,					{{META, 'Y', IDC_MY},
																															 {META+SHIFT, 'Y', IDC_MY},
																															 {'\0'}}},
	{"",							0,				0,									NULL,								{'\0'}}
};

#endif // !defined(AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_)
